View Issue Details

IDProjectCategoryView StatusLast Update
0000032file[All Projects] Generalpublic2018-10-02 01:11
ReporterChai T. RexAssigned Tochristos 
PrioritynormalSeverityminorReproducibilityhave not tried
Status resolvedResolutionfixed 
Platformx86-64, Kaby LakeOSUbuntuOS Version16.04.5
Product Version 
Target VersionFixed in Version 
Summary0000032: file declares that Bash process substitution uses a broken symlink
DescriptionApologies if this has already been fixed.

In Ubuntu 16.04.5, with file-5.25, Bash process substitution fails, claiming that there's a broken symbolic link to a pipe. The same sort of symbolic link works just fine with other programs, so there's something wrong with file's detection of broken symlinks.
Steps To Reproduce1. Note that Bash process substitution works in general, so the symlink that's involved must be properly readable:

    $ /bin/cat <( echo '#!/bin/sh' )
    #!/bin/sh

2. Note that file gives an error:

    $ /usr/bin/file <( echo '#!/bin/sh' )
    /dev/fd/63: broken symbolic link to pipe:[10713867]
Additional InformationThe version of the Ubuntu APT package called file is 1:5.25-2ubuntu1.1.

    $ /usr/bin/file --version
    file-5.25
    magic file from /etc/magic:/usr/share/misc/magic
TagsNo tags attached.
Attach Tags

Activities

christos

2018-10-01 19:24

manager   ~0000085

$ ls -l <(echo "foo bar")
lr-x------ 1 christos users 64 Oct 1 15:22 /dev/fd/63 -> pipe:[3511315244]

So what happens if you readlink(2) /dev/fd/63 and then try to open the result instead of opening it directly? What's supposed to happen?

christos

2018-10-01 20:00

manager   ~0000087

Last edited: 2018-10-01 20:01

View 2 revisions

This is only broken on Linux; other systems with a proper procfs/devfs implementation work just fine :-)

christos

2018-10-02 01:11

manager   ~0000091

Should be fixed now.

Issue History

Date Modified Username Field Change
2018-08-24 23:09 Chai T. Rex New Issue
2018-10-01 19:24 christos Note Added: 0000085
2018-10-01 20:00 christos Assigned To => christos
2018-10-01 20:00 christos Status new => feedback
2018-10-01 20:00 christos Note Added: 0000087
2018-10-01 20:01 christos Note Edited: 0000087 View Revisions
2018-10-02 01:11 christos Status feedback => resolved
2018-10-02 01:11 christos Resolution open => fixed
2018-10-02 01:11 christos Note Added: 0000091